; ResTgaReadPalette (original)
006911f0:       83 ec 14                sub    esp,0x14
; read 18 bytes from the file
006911f3:       8d 4c 24 00             lea    ecx,[esp]
006911f7:       53                      push   ebx
006911f8:       8b 5c 24 1c             mov    ebx,DWORD PTR [esp+28]
006911fc:       51                      push   ecx
006911fd:       6a 12                   push   0x12
006911ff:       8b 03                   mov    eax,DWORD PTR [ebx]
00691201:       53                      push   ebx
00691202:       ff 50 2c                call   DWORD PTR [eax+44]
; version 1
00691205:       80 7c 24 06 01          cmp    BYTE PTR [esp+6],0x1
0069120a:       74 07                   je     0x691213
; return NULL
0069120c:       33 c0                   xor    eax,eax
0069120e:       5b                      pop    ebx
0069120f:       83 c4 14                add    esp,0x14
00691212:       c3                      ret    
; 8 bits-per-pixel
00691213:       80 7c 24 14 08          cmp    BYTE PTR [esp+20],0x8
00691218:       74 07                   je     0x691221
; return NULL
0069121a:       33 c0                   xor    eax,eax
0069121c:       5b                      pop    ebx
0069121d:       83 c4 14                add    esp,0x14
00691220:       c3                      ret    
; allocate memory
00691221:       8b 44 24 20             mov    eax,DWORD PTR [esp+32]
00691225:       56                      push   esi
00691226:       57                      push   edi
00691227:       68 00 03 00 00          push   0x300
0069122c:       8b 10                   mov    edx,DWORD PTR [eax]
0069122e:       50                      push   eax
0069122f:       ff 52 0c                call   DWORD PTR [edx+12]
00691232:       8b f0                   mov    esi,eax
; initialize to zero
00691234:       b9 c0 00 00 00          mov    ecx,0xc0
00691239:       33 c0                   xor    eax,eax
0069123b:       8b fe                   mov    edi,esi
0069123d:       f3 ab                   repz stos DWORD PTR es:[edi],eax
; read colors
0069123f:       8b 44 24 0f             mov    eax,DWORD PTR [esp+15]
00691243:       8b 0b                   mov    ecx,DWORD PTR [ebx]
00691245:       25 ff ff 00 00          and    eax,0xffff
0069124a:       8d 14 46                lea    edx,[esi+eax*2]
0069124d:       03 c2                   add    eax,edx
0069124f:       50                      push   eax
00691250:       8b 44 24 15             mov    eax,DWORD PTR [esp+21]
00691254:       25 ff ff 00 00          and    eax,0xffff
00691259:       8d 04 40                lea    eax,[eax+eax*2]
0069125c:       50                      push   eax
0069125d:       53                      push   ebx
0069125e:       ff 51 2c                call   DWORD PTR [ecx+44]
; return palette
00691261:       8b c6                   mov    eax,esi
00691263:       5f                      pop    edi
00691264:       5e                      pop    esi
00691265:       5b                      pop    ebx
00691266:       83 c4 14                add    esp,0x14
00691269:       c3                      ret    
0069126a:       90                      nop    
0069126b:       90                      nop    
0069126c:       90                      nop    
0069126d:       90                      nop    
0069126e:       90                      nop    
0069126f:       90                      nop    


; ResTgaReadPalette (patched)
006911f0:       83 ec 14                sub    esp,0x14
; read 18 bytes from the file
006911f3:       8d 4c 24 00             lea    ecx,[esp]
006911f7:       53                      push   ebx
006911f8:       55                      push   ebp
006911f9:       8b 5c 24 20             mov    ebx,DWORD PTR [esp+32]
006911fd:       51                      push   ecx
006911fe:       6a 12                   push   0x12
00691200:       8b 03                   mov    eax,DWORD PTR [ebx]
00691202:       53                      push   ebx
00691203:       ff 50 2c                call   DWORD PTR [eax+44]
; allocate memory
00691206:       8b 44 24 24             mov    eax,DWORD PTR [esp+36]
0069120a:       56                      push   esi
0069120b:       57                      push   edi
0069120c:       68 00 03 00 00          push   0x300
00691211:       8b 10                   mov    edx,DWORD PTR [eax]
00691213:       50                      push   eax
00691214:       ff 52 0c                call   DWORD PTR [edx+12]
00691217:       8b e8                   mov    ebp,eax
 ; load default palette
00691219:       6a 00                   push   0x0
0069121b:       8b fd                   mov    edi,ebp
0069121d:       e8 09 59 da ff          call   0x436b2b         ; _palmgr_get_pal
00691222:       83 c4 04                add    esp,0x4
; copy default palette
00691225:       b9 c0 00 00 00          mov    ecx,0xc0
0069122a:       8b f0                   mov    esi,eax
0069122c:       f3 a5                   repz movs DWORD PTR es:[edi],DWORD PTR ds:[esi]
; version 1
0069122e:       80 7c 24 12 01          cmp    BYTE PTR [esp+18],0x1
00691233:       75 2a                   jne    0x69125f
; 8 bits-per-pixel
00691235:       80 7c 24 20 08          cmp    BYTE PTR [esp+32],0x8
0069123a:       75 23                   jne    0x69125f
; read colors
0069123c:       8b 44 24 13             mov    eax,DWORD PTR [esp+19]
00691240:       8b 0b                   mov    ecx,DWORD PTR [ebx]
00691242:       25 ff ff 00 00          and    eax,0xffff
00691247:       8d 54 45 00             lea    edx,[ebp+eax*2]
0069124b:       03 c2                   add    eax,edx
0069124d:       50                      push   eax
0069124e:       8b 44 24 19             mov    eax,DWORD PTR [esp+25]
00691252:       25 ff ff 00 00          and    eax,0xffff
00691257:       8d 04 40                lea    eax,[eax+eax*2]
0069125a:       50                      push   eax
0069125b:       53                      push   ebx
0069125c:       ff 51 2c                call   DWORD PTR [ecx+44]
; return palette
0069125f:       8b c5                   mov    eax,ebp
00691261:       5f                      pop    edi
00691262:       5e                      pop    esi
00691263:       5d                      pop    ebp
00691264:       5b                      pop    ebx
00691265:       83 c4 14                add    esp,0x14
00691268:       c3                      ret    
00691269:       90                      nop    
0069126a:       90                      nop    
0069126b:       90                      nop    
0069126c:       90                      nop    
0069126d:       90                      nop    
0069126e:       90                      nop    
0069126f:       90                      nop    
